<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

function eme_new_task() {
	$task=array(
		'event_id'=>0,
		'name'=>'',
		'spaces'=>1,
		'prio'=>0,
		'description'=>''
	);
	$task['properties'] = eme_init_task_props();
	return $task;
}

function eme_init_task_props($props=array()) {
   if (!isset($props['registered_users_only']))
      $props['registered_users_only']=0;
   if (!isset($props['require_approval']))
      $props['require_approval']=0;
   if (!isset($props['allow_overlap']))
      $props['allow_overlap']=0;
   return $props;
}

function eme_new_task_signup() {
}

function eme_db_insert_task($line) {
   global $wpdb;
   $table = $wpdb->prefix.TASKS_TBNAME;

   $tmp_task=eme_new_task();
   // we only want the columns that interest us
   $keys=array_intersect_key($line,$tmp_task);
   $task=array_merge($tmp_task,$keys);

   if ($wpdb->insert($table,$task) === false) {
      return false;
   } else {
      $task_id = $wpdb->insert_id;
      return $task_id;
   }
}

function eme_db_update_task($line) {
   global $wpdb;
   $table = $wpdb->prefix.TASKS_TBNAME;
   $where=array();
   $where['task_id']=$line['task_id'];
   if ($wpdb->update($table, $line, $where) === false)
	   $res=false;
   else
	   $res=true;
   return $res;
}

function eme_db_delete_task($task_id) {
   global $wpdb;
   $table = $wpdb->prefix.TASKS_TBNAME;
   $wpdb->delete( $table, array( 'task_id' => $task_id ) );
}

function eme_db_insert_task_signup($line) {
   global $wpdb;
   $table = $wpdb->prefix.TASK_SIGNUPS_TBNAME;
   if ($wpdb->insert($table,$line) === false) {
      return false;
   } else {
      $signup_id = $wpdb->insert_id;
      return $signup_id;
   }
}

function eme_db_update_task_signup($line) {
   global $wpdb;
   $table = $wpdb->prefix.TASK_SIGNUPS_TBNAME;
   $where=array();
   $where['id']=$line['id'];
   if ($wpdb->update($table, $line, $where) === false)
	   $res=false;
   else
	   $res=true;
   return $res;
}

function eme_db_delete_task_signup($signup_id) {
   global $wpdb;
   $table = $wpdb->prefix.TASK_SIGNUPS_TBNAME;
   $wpdb->delete( $table, array( 'id' => $signup_id ) );
}

function eme_get_tasks($event_id) {
   global $wpdb;
   $table = $wpdb->prefix.TASKS_TBNAME;
   $sql = $wpdb->prepare("SELECT * FROM $table WHERE event_id=%d",$event_id);
   $tasks = $wpdb->get_results($sql, ARRAY_A);
   // don't forget the properties
   if ($tasks) {
	   foreach ($tasks as $key=>$task) {
		   $tasks[$key] = eme_init_task_props($task);
	   }
   }
}

function eme_get_task_signups($event_id) {
   global $wpdb;
   $table = $wpdb->prefix.TASK_SIGNUPS_TBNAME;
   $sql = $wpdb->prepare("SELECT * FROM $table WHERE event_id=%d",$event_id);
   return $wpdb->get_results($sql, ARRAY_A);
}

function eme_meta_box_div_event_task_signup_approved_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Made Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email sent to the respondent when that person signs up for a task (not pending) or approved.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_email_subject_tpl'],'eme_prop_task_signup_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Made Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email sent to the respondent when that person signs up for a task (not pending) or approved.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_email_body_tpl'],'eme_prop_task_signup_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Made Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person when someone signs up for a task.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_email_subject_tpl'],'eme_prop_cp_task_signup_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Made Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person when someone signs up for a task.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_email_body_tpl'],'eme_prop_cp_task_signup_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_pending_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Pending Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_pending_email_subject_tpl'],'eme_prop_task_signup_pending_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Pending Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_pending_email_body_tpl'],'eme_prop_task_signup_pending_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Pending Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person if a task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_pending_email_subject_tpl'],'eme_prop_cp_task_signup_pending_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Pending Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person if a task signup requires approval.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_pending_email_body_tpl'],'eme_prop_cp_task_signup_pending_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_updated_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Updated Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup has been updated by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_updated_email_subject_tpl'],'eme_prop_task_signup_updated_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Updated Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup has been updated by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_updated_email_body_tpl'],'eme_prop_task_signup_updated_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_cancelled_email($event,$templates_array) {
?>
<div>
   <b><?php _e('Task Signup Cancelled Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent when he himself cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_cancelled_email_subject_tpl'],'eme_prop_task_signup_cancelled_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Cancelled Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent when he himself cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_cancelled_email_body_tpl'],'eme_prop_task_signup_cancelled_email_body_tpl',$templates_array); ?>
</div>
<br />
<div>
   <b><?php _e('Contact Person Task Signup Cancelled Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the contact person when a respondent cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_cancelled_email_subject_tpl'],'eme_prop_cp_task_signup_cancelled_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Contact Person Task Signup Cancelled Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the contact person when a respondent cancels a task signup.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['cp_task_signup_cancelled_email_body_tpl'],'eme_prop_cp_task_signup_cancelled_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_trashed_email($event,$templates_array) {
?>
<div id="div_event_registration_trashed_email">
   <b><?php _e('Task Signup Deleted Email Subject', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The subject of the email which will be sent to the respondent if the task signup is deleted by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_trashed_email_subject_tpl'],'eme_prop_task_signup_trashed_email_subject_tpl',$templates_array); ?>
   <br />
   <br />
   <b><?php _e('Task Signup Deleted Email Body', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The body of the email which will be sent to the respondent if the task signup is deleted by an admin.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy'); echo eme_ui_select($event['event_properties']['task_signup_trashed_email_body_tpl'],'eme_prop_task_signup_trashed_email_body_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_form_format($event,$templates_array) {
?>
<div id="div_event_task_signup_form_format">
   <b><?php _e('Task Signup Form', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The layout of the task signup form.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy');?>
   <?php echo eme_ui_select($event['event_properties']['task_signup_form_format_tpl'],'eme_prop_task_signup_form_format_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_task_signup_recorded_ok_html($event,$templates_array) {
?>
<div id="div_event_task_signup_recorded_ok_html">
   <b><?php _e('Signup recorded message', 'events-made-easy'); ?></b>
   <p class="eme_smaller"><?php _e ( 'The text (html allowed) shown to the user when the task signup has been made successfully.','events-made-easy');?></p>
   <br />
   <?php _e ('Only choose a template if you want to override the default settings:', 'events-made-easy');?>
   <?php echo eme_ui_select($event['event_properties']['task_signup_recorded_ok_html_tpl'],'eme_prop_task_signup_recorded_ok_html_tpl',$templates_array); ?>
</div>
<?php
}

function eme_meta_box_div_event_tasks($event) {
}

?>
